var Index = function()
{
	var index = {};
	var debug = 0;
	var myPermissions = {};

	var counters;
	var counterNo = -1;
	
	
	index.initPage = function()
	{
		Events.doOnEnter('caseName', index.caseSummary);
		Events.addEventHandler('caseName', 'keypress', index.testSnake);
		Buttons.addClickHandler('btnCaseSummary', index.caseSummary);
		index.initPermissions();
		counters = document.getElementsByClassName('counter');
		index.countNext();
		
		var frm = document.forms['reggie'];
		frm.caseName.disabled = !App.getActiveProjectId();
	}
	
	index.initPermissions = function()
	{
		// Get permission information
		var url = 'Install.servlet?ID='+App.getSessionId();
		url += '&cmd=GetPermissions';
		var request = Ajax.getXmlHttpRequest();
		request.open("GET", url, true);
		Ajax.setReadyStateHandler(request, index.onPermissionsLoaded, index.onPermissionsLoaded);
		request.send(null);
	}
	
	// Callback when permission information is ready
	index.onPermissionsLoaded = function(request)
	{
		if (debug) App.debug(Strings.encodeTags(request.responseText));
		var response;
		var error = false;
		try
		{
			response = JSON.parse(request.responseText);
			if (response.status != 'ok')
			{
				error = response.message || response.stacktrace || 'Unexpected error';
			}
		}
		catch (ex)
		{
			error = ex;
		}
		
		if (error)
		{
			alert(error);
			return;
		}
		
		myPermissions = response.permissions;
		var isAdmin = myPermissions['Administrator'] == 1;
		var noProjectIsActive = !App.getActiveProjectId();
		
		// Enable links based on the permission
		var wizards = document.getElementsByClassName('require-permission');
		// NOTE! Loop backwards since changing the classname 
		// of an element so that 'require-permission' no longer is included
		// removes the element from the 'wizards' list
		for (var wizardNo = wizards.length-1; wizardNo >= 0; wizardNo--)
		{
			var wizard = wizards[wizardNo];
			if (wizard.className.indexOf('not-implemented') == -1)
			{
				var role = wizard.getAttribute('data-role');
				if (noProjectIsActive)
				{
					wizard.title = 'You must select a project before using this wizard';
				}
				else if (!role || myPermissions[role] == 1 || isAdmin)
				{
					wizard.className = 'link';
					wizard.addEventListener('click', index.wizardOnClick);
				}
				else
				{
					wizard.title = 'You do not have permission to user this wizard';
				}
			}
		}
	}

	index.wizardOnClick = function(event)
	{
		var role = Data.get(event.currentTarget, 'role');
		var isAdmin = myPermissions['Administrator'] == 1;
		if (!role || myPermissions[role] == 1 || isAdmin)
		{
			var link = Data.get(event.currentTarget, 'link');
			location.href = link;
		}
		else
		{
			Forms.showNotification(event.currentTarget, 'You do not have permission to use this wizard!', null, null, 'left');
		}
	}

	index.countNext = function()
	{
		counterNo++
		if (counterNo >= counters.length) return;
		var counter = counters[counterNo];
		
		var copyFrom = Data.get(counter, 'copy-from');
		var servlet = Data.get(counter, 'servlet');
		if (copyFrom)
		{
			var orig = Doc.element(copyFrom);
			Doc.addClass(counter, 'done');
			counter.innerHTML = orig.innerHTML;
			counter.title = orig.title;
			setTimeout(index.countNext, 50);
		}
		else if (servlet)
		{
			counter.innerHTML = '<img src="images/loading-small.gif">';
			var url = servlet + '&ID='+App.getSessionId();
			if (debug) App.debug(url);
			var request = Ajax.getXmlHttpRequest();
			request.open("GET", url, true);
			Ajax.setReadyStateHandler(request, index.onCounted, index.onCounted);
			request.send(null);
		}
		else
		{
			Doc.addClass(counter, 'done');
			counter.innerHTML = '-';
			counter.title = 'Undefined counter'
			setTimeout(index.countNext, 50);
		}
		
	}
	
	index.onCounted = function(request)
	{
		var counter = counters[counterNo];
		if (debug) 
		{
			App.debug(counter.id +': ' + Strings.encodeTags(request.responseText));
		}

		var response;
		var error = false;
		try
		{
			response = JSON.parse(request.responseText);
			if (response.status != 'ok')
			{
				error = response.message || response.stacktrace || 'Unexpected error';
			}
		}
		catch (ex)
		{
			error = ex;
		}
		
		var count = error ? -1 : response.count;
		if (error) counter.title = error;
		
		Doc.addClass(counter, 'done');
		if (count == -1)
		{
			counter.innerHTML = '-';
		}
		else
		{
			counter.innerHTML = count;
		}
		
		index.countNext();
	}
	
	index.caseSummary = function()
	{
		var frm = document.forms['reggie'];
		
		var caseName = frm.caseName.value;
		if (!caseName)
		{
			Forms.showNotification('caseName', 'Please enter a 7-digit case id', null, null, 'left');
			return;
		}
		var url = 'reports/case_summary.jsp?ID='+App.getSessionId();
		url += '&caseName='+encodeURIComponent(caseName);
		location.href = url;
	}
	
	index.testSnake = function(event)
	{
		if (event.currentTarget.value == 'Snak' && event.charCode == 101)
		{
			setTimeout(index.showSnake, 500);
		}
	}

	index.showSnake = function()
	{
		var msg = '<img src="images/snake-icon-64.png" style="float: right;">'
		msg += '– There\'s a big snake in the plane, Jock!<br>';
		msg += '– Oh, that\'s just my pet snake, Reggie!<br>';
		msg += '– I hate snakes, Jock! I hate \'em!<br>';
		msg += '– Come on! Show a little backbone, will ya?<br>';
		msg += '<div class="snake-quote-source">Indiana Jones - Raiders of the Lost Ark</div>';
		Forms.showNotification('caseName', msg, 'snake-quote', 'pointer-above');
	}

	
	return index;
}();

Doc.onLoad(Index.initPage);

